string GetPuppetTagByConstant(int intParam1) {
	switch(intParam1){
		case 0:
			return "remote";
			break;
	}
	return "ERROR";
}

object SpawnPuppetAtWaypoint(int nPuppet, string sWP) {
	string wPuppet;
	if(sWP == "WP_gspawn_"){
		string sPuppet = GetPuppetTagByConstant(nPuppet);
		if(sPuppet == "ERROR"){
			return OBJECT_INVALID;
		}
		wPuppet = (sWP + sPuppet);
	}
	else{
		wPuppet = sWP;
	}
	object oWP = GetObjectByTag(wPuppet);
	object oPuppet;
	if(GetIsObjectValid(oWP)){
		oPuppet = SpawnAvailablePUP(nPuppet, GetLocation(oWP));
		if(GetIsObjectValid(oPuppet)){
			return oPuppet;
		}
	}
	return OBJECT_INVALID;
}

string GetNPCTagByConstant(int intParam1){
	switch(intParam1){
		case 0:
			return "atton";
			break;
		case 1:
			return "baodur";
			break;
		case 2:
			return "mand";
			break;
		case 11:
			return "disciple";
			break;
		case 3:
			return "g0t0";
			break;
		case 4:
			return "handmaiden";
			break;
		case 10:
			return "hanharr";
			break;
		case 5:
			return "hk47";
			break;
		case 6:
			return "kreia";
			break;
		case 7:
			return "mira";
			break;
		case 8:
			return "t3m4";
			break;
		case 9:
			return "visasmarr";
			break;
	}
	return "ERROR";
}

//Spawns the NPC at the entered waypoint
object SpawnNPCAtWaypoint(int nNPC, string sWP) {
	string wNPC;
	if(sWP == "WP_gspawn_"){
		string sNPC = GetNPCTagByConstant(nNPC);
		if(sNPC == "ERROR"){
			return OBJECT_INVALID;
		}
		wNPC = (sWP + sNPC);
	}
	else{
		wNPC = sWP;
	}
	object oWP = GetObjectByTag(wNPC);
	object oNPC;
	if(GetIsObjectValid(oWP)){
		oNPC = SpawnAvailableNPC(nNPC, GetLocation(oWP));
		if(GetIsObjectValid(oNPC)){
			SetCreatureAILevel(oNPC, 3);
			return oNPC;
		}
	}
	return OBJECT_INVALID;
}

//Spawns all party members at waypoints tagged: WP_gspawn_*NPC_TAG*
void SpawnParty(){
	int int1 = 0;
	while(int1 < 12){
		if(GetNPCSelectability(int1) != -1){
			if(GetIsObjectValid(SpawnNPCAtWaypoint(int1, "WP_gspawn_"))){
				if(int1 == 1){
					SpawnPuppetAtWaypoint(0, "WP_gspawn_");
				}
			}
		}
		int1++;
	}
}

//Removes the entire party
void RemoveParty(){
	SetPartyLeader(-1);
	int int2 = 0;
	while(int2 < 12){
		if(IsNPCPartyMember(int2)){
			RemoveNPCFromPartyToBase(int2);
		}
		int2++;
	}
}

//Revives all party members at 1 HP.
void ResurrectParty(){
	int n = 0;
	object oNPC = GetPartyMemberByIndex(n);
	while(GetIsObjectValid(oNPC)){
		if(GetCurrentHitPoints(oNPC) < 1){
			ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectResurrection(0), oNPC);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectHeal(1), oNPC);
		}
		n++;
		oNPC = GetPartyMemberByIndex(n);
	}
}


string NPCnameGEN(int nNPC){
	switch(nNPC){
		case -1:
			return "The Exile's";
		case 0:
			return "Atton's";
		case 1:
			return "Bao-Dur's";
		case 2:
			return "Mandalore's";
		case 3:
			return "G0-T0's";
		case 4:
			return "Handmaiden's";
		case 5:
			return "HK-47's";
		case 6:
			return "Kreia's";
		case 7:
			return "Mira's";
		case 8:
			return "T3-M4's";
		case 9:
			return "Visas'";
		case 10:
			return "Hanharr's";
		case 11:
			return "Disciple's";
		case 12:
			return "The Exile's";
	}
	return "Error";
}

string NPCname(int nNPC){
	switch(nNPC){
		case 0:
			return "Atton";
		case 1:
			return "Bao-Dur";
		case 2:
			return "Mandalore";
		case 3:
			return "G0-T0";
		case 4:
			return "Handmaiden";
		case 5:
			return "HK-47";
		case 6:
			return "Kreia";
		case 7:
			return "Mira";
		case 8:
			return "T3-M4";
		case 9:
			return "Visas";
		case 10:
			return "Hanharr";
		case 11:
			return "Disciple";
	}
	return "Error";
}