#include "k_inc_obsidian.nss"

void SpawnDummy(vector vPos, float fFacing);
void GrantAllPowers(object oObject = OBJECT_SELF);

void Error(string sMsg = "Unknown error."){
	SendMessageToPC(GetPartyLeader(), "WORKBOX ERROR: "+sMsg);
}

void main(){
	int Param1 = GetScriptParameter(1);
	int Param2 = GetScriptParameter(2);
	int Param3 = GetScriptParameter(3);
	int Param4 = GetScriptParameter(4);
	int Param5 = GetScriptParameter(5);
	string ParamString = GetScriptStringParameter();

	object oSelf = GetPCSpeaker();

	int bNumBool = GetLocalBoolean(oSelf, 30); //TRUE - boolean, FALSE - number

	string sID = GetGlobalString("000_sID");

	int nNPC = GetLocalNumber(oSelf, 20);
	int nDigit1 = GetLocalNumber(oSelf, 21);
	int nDigit2 = GetLocalNumber(oSelf, 22);
	int nLocal = GetLocalNumber(oSelf, 23);
	int nSpecific = GetLocalNumber(oSelf, 24); //Specific skill/attribute
	int nQuantity = GetLocalNumber(oSelf, 25); //1-influence, 2-alignment, 3-skills, 4-attributes
	int nInstance = GetLocalNumber(oSelf, 26); //Object instance

	int QUANTITY_INFLUENCE = 1;
	int QUANTITY_ALIGNMENT = 2;
	int QUANTITY_SKILL = 3;
	int QUANTITY_ATTRIBUTE = 4;

	switch(Param1){
		case 0:{ //Run module pre dialog
			string sDLG = "pre"+GetModuleFileName();
			object oDLG = GetObjectByTag(GetStringLeft(GetModuleFileName(), 3)+"dlghost");
			if(GetIsObjectValid(oDLG)){
				DelayCommand(0.1, AssignCommand(oDLG, ActionStartConversation(oDLG, sDLG)));
			}
			else Error("Cannot find dlghost.");
		break;}
		case 1:{ //Load new module (warp)
			StartNewModule(ParamString);
		break;}
		case 2:{ //Fire camtest.dlg
			DelayCommand(0.1, AssignCommand(oSelf, ActionStartConversation(oSelf, "camtest")));
		break;}
		case 3:{ //Opens/Closes nearest door
			object oDoor;
			oDoor = GetNearestObject(OBJECT_TYPE_DOOR, oSelf);
			if(GetIsOpen(oDoor)) AssignCommand(oDoor, ActionCloseDoor(oDoor));
			else AssignCommand(oDoor, ActionOpenDoor(oDoor));
		break;}
		case 4: //Show current influence; Param2 - NPC_*, Param3 - token
			SetCustomToken(Param3, IntToString(GetInfluence(Param2)));
		break;
		case 5: //Modify influence
			SetInfluence(nNPC, (10*nDigit1 + nDigit2));
		break;
		case 6: //Show current alignment; Param2 - token
			SetCustomToken(Param2, IntToString(GetGoodEvilValue(GetFirstPC())));
		break;
		case 7: //Modify alignment
			SetGoodEvilValue(GetFirstPC(), (10*nDigit1+nDigit2));
		break;
		case 8:{ //Show current gender; Param2 - token
			string sString;
			if(GetGlobalBoolean("000_PLAYER_GENDER")) sString="male";
			else sString="female";
			SetCustomToken(Param2, sString);
		break;}
		case 9: //Add party member (by the p_*.utc templates, which might cause some issues); Param2 - NPC_*
			switch(Param2){
				case 0:
					AddAvailableNPCByTemplate(NPC_ATTON, "p_atton");
				break;
				case 1:
					AddAvailableNPCByTemplate(NPC_BAO_DUR, "p_baodur");
				break;
				case 2:
					AddAvailableNPCByTemplate(NPC_CANDEROUS, "p_mand");
				break;
				case 3:
					AddAvailableNPCByTemplate(NPC_G0T0, "p_g0t0");
				break;
				case 4:
					AddAvailableNPCByTemplate(NPC_HANDMAIDEN, "p_handmaiden");
				break;
				case 5:
					AddAvailableNPCByTemplate(NPC_HK_47, "p_hk47");
				break;
				case 6:
					AddAvailableNPCByTemplate(NPC_KREIA, "p_kreia");
				break;
				case 7:
					AddAvailableNPCByTemplate(NPC_MIRA, "p_mira");
				break;
				case 8:
					AddAvailableNPCByTemplate(NPC_T3_M4, "p_t3m4");
				break;
				case 9:
					AddAvailableNPCByTemplate(NPC_VISAS, "p_visas");
				break;
				case 10:
					AddAvailableNPCByTemplate(NPC_HANHARR, "p_hanharr");
				break;
				case 11:
					AddAvailableNPCByTemplate(NPC_DISCIPLE, "p_disciple");
				break;
			}
		break;
		case 10:{ //Show current attribute/skill level for chosen party member; Param2 - skill/attribute, Param3 - token
			SetLocalNumber(oSelf, 24, Param2);
			int nValue;
			if(nQuantity == QUANTITY_SKILL){
				if(nNPC == -1 || nNPC == 12) nValue = GetSkillRankBase(Param2, GetFirstPC());
				else nValue = GetSkillRankBase(Param2, GetObjectByTag(GetNPCTagByConstant(nNPC)));
			}
			else if(nQuantity == QUANTITY_ATTRIBUTE){
				if(nNPC == -1 || nNPC == 12) nValue = GetAbilityScore(GetFirstPC(), Param2);
				else nValue = GetAbilityScore(GetObjectByTag(GetNPCTagByConstant(nNPC)), Param2);
			}
			else Error();
			
			switch(Param2){
				case 0:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Computer Use: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Strength: "+IntToString(nValue));
					}
					else Error();
				break;
				case 1:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Demolitions: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Dexterity: "+IntToString(nValue));
					}
					else Error();
				break;
				case 2:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Stealth: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Constitutions: "+IntToString(nValue));
					}
					else Error();
				break;
				case 3:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Awareness: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Intelligence: "+IntToString(nValue));
					}
					else Error();
				break;
				case 4:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Persuade: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Wisdom: "+IntToString(nValue));
					}
					else Error();
				break;
				case 5:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Repair: "+IntToString(nValue));
					}
					else if(nQuantity == QUANTITY_ATTRIBUTE){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Charisma: "+IntToString(nValue));
					}
					else Error();
				break;
				case 6:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Security: "+IntToString(nValue));
					}
					else Error();
				break;
				case 7:
					if(nQuantity == QUANTITY_SKILL){
						SetCustomToken(Param3, NPCnameGEN(nNPC)+" Treat Injury: "+IntToString(nValue));
					}
					else Error();
				break;
			}
		break;}
		case 11:{ //Modify skill/attribute
			if(nQuantity==QUANTITY_SKILL){
				int nValue = 10*nDigit1+nDigit2;
				if(nNPC == -1 || nNPC == 12){
					int nCurrent = GetSkillRankBase(nSpecific, GetFirstPC());
					AdjustCreatureSkills(GetFirstPC(), nSpecific, nValue-nCurrent);
				}
				else{
					int nCurrent = GetSkillRankBase(nSpecific, GetObjectByTag(GetNPCTagByConstant(nNPC)));
					AdjustCreatureSkills(GetObjectByTag(GetNPCTagByConstant(nNPC)), nSpecific, nValue-nCurrent);
				}
			}
			else if(nQuantity==QUANTITY_ATTRIBUTE){
				int nValue = 10*nDigit1+nDigit2;
				if(nNPC == -1 || nNPC == 12){
					int nCurrent = GetAbilityScore(GetFirstPC(), nSpecific);
					AdjustCreatureAttributes(GetFirstPC(), nSpecific, nValue-nCurrent);
				}
				else{
					int nCurrent = GetAbilityScore(GetObjectByTag(GetNPCTagByConstant(nNPC)), nSpecific);
					AdjustCreatureAttributes(GetObjectByTag(GetNPCTagByConstant(nNPC)), nSpecific, nValue-nCurrent);
				}
			}
			else Error();
		break;}
		case 12:{ //Gets rid of all dummies
			object oDummy = GetObjectByTag("n_wp_dummy");
			int i = 1;
			while(GetIsObjectValid(oDummy)){
				DestroyObject(oDummy);
				oDummy = GetObjectByTag("n_wp_dummy", i);
				i++;
			}
		break;}
		case 13:{ //Destroy nearest object
			object oNearest = GetNearestObject(OBJECT_TYPE_CREATURE | OBJECT_TYPE_PLACEABLE | OBJECT_TYPE_TRIGGER | OBJECT_TYPE_WAYPOINT | OBJECT_TYPE_DOOR, oSelf);
			AssignCommand(oNearest, SetIsDestroyable(TRUE, FALSE, FALSE));
			DestroyObject(oNearest);

		break;}
		case 14:{ //Spawn dummy
			vector vPos = GetPosition(oSelf);
			float fFacing = GetFacing(oSelf);
			DelayCommand(1.0, SpawnDummy(vPos, fFacing));
		break;}
		case 15:{ //Store values and update token
			SetLocalNumber(oSelf, 23, Param3);
			SetLocalBoolean(oSelf, 30, Param2);
			SetGlobalString("000_sID", ParamString);
			SetLocalNumber(oSelf, 26, Param5);

			nLocal = GetLocalNumber(oSelf, 23);
			bNumBool = GetLocalBoolean(oSelf, 30);
			sID = GetGlobalString("000_sID");
			nInstance = GetLocalNumber(oSelf, 26);

			int nValue;
			string sToken;
			object oObject;
			if(nLocal > 0 && sID == "") oObject = oSelf;
			else if(nLocal > 0) oObject = GetObjectByTag(sID, nInstance);

			if(sID == "" && nLocal == 0) sToken = "GLOBAL ID MISSING!";
			else if(nLocal>0){ //It's local
				if(GetIsObjectValid(oObject)){
					if(bNumBool){ //It's a boolean
						nValue = GetLocalBoolean(oObject, nLocal);
						if(nValue) sToken = "TRUE";
						else sToken = "FALSE";
					}
					else{ //It's a number
						nValue = GetLocalNumber(oObject, nLocal);
						sToken = IntToString(nValue);
					}
				}
				else sToken = "OBJECT NOT VALID!";
			}
			else{ //It's global
				if(bNumBool){ //It's a boolean
					nValue = GetGlobalBoolean(sID);
					if(nValue) sToken = "TRUE";
					else sToken = "FALSE";
				}
				else{ //It's a number
					nValue = GetGlobalNumber(sID);
					sToken = IntToString(nValue);
				}
			}
			SetCustomToken(36, sToken);
		break;}
		case 16:{
			object oObject;
			if(nLocal > 0 && sID == "") oObject = oSelf;
			else if(nLocal > 0) oObject = GetObjectByTag(sID, nInstance);

			if(sID == "" && nLocal == 0) Error("Updating global - ID not set.");
			else if(nLocal>0){ //It's local
				if(GetIsObjectValid(oObject)){
					if(bNumBool){ //It's a boolean
						SetLocalBoolean(oObject, nLocal, Param2);
					}
					else{ //It's a number
						SetLocalNumber(oObject, nLocal, Param2);
					}
				}
				else Error("Updating local - object not found. ("+sID+", "+IntToString(nInstance)+")");
			}
			else{ //It's global
				if(bNumBool){ //It's a boolean
					SetGlobalBoolean(sID, Param2);
				}
				else{ //It's a number
					SetGlobalNumber(sID, Param2);
				}
			}
		break;}
		case 17:
			GrantAllPowers(oSelf);
		break;
		default:
			Error("Param1 invalid.");
		break;
	}
}

void SpawnDummy(vector vPos, float fFacing){
	object oNearest = GetNearestObjectToLocation(OBJECT_TYPE_ALL, Location(vPos, fFacing));
	object oShape = GetFirstObjectInShape(SHAPE_SPHERE, 0.9, Location(vPos, fFacing));
	if(GetIsObjectValid(oShape)){
		if(IsObjectPartyMember(oShape)) DelayCommand(1.0, SpawnDummy(vPos, fFacing));
		else Error("A non-partymember object prevented the Dummy to spawn.");
	}
	else{
		CreateObject(OBJECT_TYPE_CREATURE, "n_wp_dummy", Location(vPos, fFacing));
	}
}

void GrantAllPowers(object oObject = OBJECT_SELF){
	int nJediLevels = GetLevelByClass(CLASS_TYPE_JEDIGUARDIAN, oObject) +
			GetLevelByClass(CLASS_TYPE_JEDISENTINEL, oObject) +
			GetLevelByClass(CLASS_TYPE_JEDICONSULAR, oObject) +
			GetLevelByClass(CLASS_TYPE_JEDIWEAPONMASTER, oObject) +
			GetLevelByClass(CLASS_TYPE_JEDIMASTER, oObject) +
			GetLevelByClass(CLASS_TYPE_JEDIWATCHMAN, oObject) +
			GetLevelByClass(CLASS_TYPE_SITHMARAUDER, oObject) +
			GetLevelByClass(CLASS_TYPE_SITHLORD, oObject) +
			GetLevelByClass(CLASS_TYPE_SITHASSASSIN, oObject);
	if(nJediLevels > 0){ //if Jedi
		int n = 0;
		while(n<300){
			if(!GetSpellAcquired(n, oObject) && GetSpellBaseForcePointCost(n) > 0) GrantSpell(n, oObject);
			n++;
		}
	}
	else Error("Cannot grant force powers to non-Jedi.");
}
